# -*- coding: utf-8 -*-
# Generated by Django 1.11.29 on 2021-08-26 10:28
from __future__ import unicode_literals

from django.db import migrations, models
from django.db.models import Count
from core.model_utils import merge_models


def deduplicate_keywords(apps, schema_editor):
    """Merges duplicated keyword models """
    Keyword = apps.get_model("submission", "Keyword")
    to_fix = Keyword.objects.values(
        "word"
    ).annotate(
        Count("id")
    ).order_by().filter(id__count__gt=1).values("word")

    for word in to_fix:
        kws = Keyword.objects.filter(word=word["word"])
        original = kws[0]
        for kw in kws[1:]:
            merge_models(kw, original)


class Migration(migrations.Migration):
    atomic = False
    dependencies = [
        ('submission', '0056_auto_20210803_0906'),
    ]
    operations = [
        migrations.RunPython(
            deduplicate_keywords, migrations.RunPython.noop
        ),
        migrations.AlterField(
            model_name='keyword',
            name='word',
            field=models.CharField(max_length=200, unique=True),
        ),
    ]
